
#include <vector>
#include <memory>
#include <cstdint>

void init_ntl_random();

struct goppa_generator
{
    struct data_t;
    std::unique_ptr<data_t> data;

    goppa_generator(std::vector<bool> const &fieldpoly, size_t t);
    ~goppa_generator();

    void next(std::string &poly, std::vector<std::vector<bool>> &cols);

    std::string fmt_felt(size_t which) const;
};

